<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "waiting_room_guest".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "WaitingRoomGuest".
 *
 * Columns in table "waiting_room_guest" available as properties of the model,
 * followed by relations of table "waiting_room_guest" available as properties of the model.
 *
 * @property integer $id
 * @property string $guid
 * @property integer $waiting_room_invite_id
 * @property string $type
 * @property integer $patient_id
 * @property integer $provider_id
 * @property string $nickname
 * @property string $first_name
 * @property string $last_name
 * @property string $title
 * @property string $phone_number
 * @property integer $visit_reason_id
 * @property string $email
 * @property integer $review_request_id
 * @property integer $overall_rating
 * @property integer $review_request_complete
 * @property integer $review_request_reminder_sent
 * @property string $date_added
 * @property string $connected
 * @property string $disconnected
 * @property string $invite_sent
 *
 * @property Patient $patient
 * @property Provider $provider
 * @property WaitingRoomInvite $waitingRoomInvite
 */
abstract class BaseWaitingRoomGuest extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'waiting_room_guest';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'WaitingRoomGuest|WaitingRoomGuests', $n);
    }

    public static function representingColumn()
    {
        return 'guid';
    }

    public function rules()
    {
        return array(
            array('guid, waiting_room_invite_id, nickname, first_name, last_name, date_added', 'required'),
            array('waiting_room_invite_id, patient_id, provider_id, visit_reason_id, review_request_id, overall_rating, review_request_complete, review_request_reminder_sent', 'numerical', 'integerOnly' => true),
            array('guid', 'length', 'max' => 36),
            array('type', 'length', 'max' => 1),
            array('nickname', 'length', 'max' => 51),
            array('first_name, last_name, email', 'length', 'max' => 255),
            array('phone_number', 'length', 'max' => 14),
            array('type, patient_id, provider_id, phone_number, visit_reason_id, email, review_request_id, overall_rating, review_request_complete, review_request_reminder_sent, connected, disconnected, invite_sent', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, guid, waiting_room_invite_id, type, patient_id, provider_id, nickname, first_name, last_name, phone_number, visit_reason_id, email, review_request_id, overall_rating, review_request_complete, review_request_reminder_sent, date_added, invite_sent, title', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'patient' => array(self::BELONGS_TO, 'Patient', 'patient_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'waitingRoomInvite' => array(self::BELONGS_TO, 'WaitingRoomInvite', 'waiting_room_invite_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'guid' => Yii::t('app', 'Guid'),
            'waiting_room_invite_id' => null,
            'type' => Yii::t('app', 'Type'),
            'patient_id' => null,
            'provider_id' => null,
            'nickname' => Yii::t('app', 'Nickname'),
            'first_name' => Yii::t('app', 'First Name'),
            'last_name' => Yii::t('app', 'Last Name'),
            'title' => Yii::t('app', 'Title'),
            'phone_number' => Yii::t('app', 'Phone Number'),
            'visit_reason_id' => Yii::t('app', 'Visit Reason'),
            'email' => Yii::t('app', 'Email'),
            'review_request_id' => Yii::t('app', 'Review Request'),
            'overall_rating' => Yii::t('app', 'Overall Rating'),
            'review_request_complete' => Yii::t('app', 'Review Request Complete'),
            'review_request_reminder_sent' => Yii::t('app', 'Review Request Reminder Sent'),
            'date_added' => Yii::t('app', 'Date Added'),
            'patient' => null,
            'provider' => null,
            'waitingRoomInvite' => null,
            'connected' => null,
            'disconnected' => null,
            'invite_sent' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('guid', $this->guid, true);
        $criteria->compare('waiting_room_invite_id', $this->waiting_room_invite_id);
        $criteria->compare('type', $this->type, true);
        $criteria->compare('patient_id', $this->patient_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('nickname', $this->nickname, true);
        $criteria->compare('first_name', $this->first_name, true);
        $criteria->compare('last_name', $this->last_name, true);
        $criteria->compare('title', $this->title, true);
        $criteria->compare('phone_number', $this->phone_number, true);
        $criteria->compare('visit_reason_id', $this->visit_reason_id);
        $criteria->compare('email', $this->email, true);
        $criteria->compare('review_request_id', $this->review_request_id);
        $criteria->compare('overall_rating', $this->overall_rating);
        $criteria->compare('review_request_complete', $this->review_request_complete);
        $criteria->compare('review_request_reminder_sent', $this->review_request_reminder_sent);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('connected', $this->connected, true);
        $criteria->compare('disconnected', $this->disconnected, true);
        $criteria->compare('invite_sent', $this->invite_sent, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }
}
